//<c>   Copyright 1986-2000 by Gerry J. Danen; all rights reserved.

//<t>   The official Trudeau salute...

#include"gd_tools.h"
#include"gd_ansi.h"
#pragma check_stack(off)


char    *pic1 = "ͻ",
        *pic2 = "",
        *pic3 = "",
        *pic4 = "       ",
        *pic5 = "",
        *pic6 = "",
        *pic7 = "" ;


//      Makes the PC speaker emit a sound at `frequency' Herz for
//      approximately `duration' milliseconds.

void    sound( short frequency, long duration )
{
    clock_t start;

    duration *= CLK_TCK;
    duration /= 1000;
    frequency = (short) (1193180L / (long) frequency);
    (void) outp ( 0x43, 182 );
    (void) outp ( 0x42, frequency & 0xFF );
    (void) outp ( 0x42, frequency >> 8 );

    start = clock();
    (void) outp ( 0x61, inp ( 0x61 ) | 3 );
    while ( clock() - start < duration ) ;
    (void) outp ( 0x61, inp ( 0x61 ) & 0xFC );
}


void    beep(void)
{
    sound( 1400, 60 );
}


void    buzzer(void)
{
    sound( 80, 400 );
}


void    delay( int secs )
{
    long        hsecs ;

    hsecs = secs * 100L ;
    TimerInit( hsecs );
    while ( ! TimedOut() )
        ;
}


void    color( int attr, int fg, int bg )
/*
        attr:   0 = no change
                1 = normal video
                2 = high intensity
                3 = underscore (monochrome adapter only)
                4 = blink
                5 = reverse video
                6 = invisible (fg = bg)
        fg/bg:  0 = no change
                1 = black
                2 = red
                3 = green
                4 = yellow
                5 = blue
                6 = magenta
                7 = cyan
                8 = white
*/
{
    if ( attr > 0 && attr < 7 )
    {
        fprintf( stderr, "\033[" );
        switch ( attr )
        {
            case 1: fprintf( stderr, "0m" );    // normal
                    break;
            case 2: fprintf( stderr, "1m" );    // high intensity
                    break;
            case 3: fprintf( stderr, "4m" );    // underscore
                    break;
            case 4: fprintf( stderr, "5m" );    // blink
                    break;
            case 5: fprintf( stderr, "7m" );    // reverse video
                    break;
            case 6: fprintf( stderr, "8m" );    // invisible
                    break;
        }
    }
    if ( fg > 0 && fg < 9 )
        fprintf( stderr, "\033[%dm", fg+29 );   // foreground color
    if ( bg > 0 && bg < 9 )
        fprintf( stderr, "\033[%dm", bg+39 );   // background color
}


void    locate( int row, int col )
{
    fprintf( stderr, "\033[%d;%dH", row, col );
}


void    print_at( int row, int col, STRING str )
{
    locate( row, col );
    fprintf( stderr, "%s", str );
}


void    finger_up( void )
{
    beep();
    print_at(  4, 32, pic1 );
    print_at(  5, 32, pic2 );
    print_at(  6, 32, pic2 );
    print_at(  7, 32, pic2 );
    print_at(  8, 32, pic2 );
    print_at(  9, 32, pic2 );
    print_at( 13, 32, pic3 );
    print_at( 14, 32, pic3 );
    locate( 24, 51 );
    delay( 2 );
}


void    finger_down( void )
{
    beep();
    print_at(  4, 32, pic4 );
    print_at(  5, 32, pic4 );
    print_at(  6, 32, pic4 );
    print_at(  7, 32, pic4 );
    print_at(  8, 32, pic4 );
    print_at(  9, 32, "  " );
    print_at( 13, 32, pic2 );
    print_at( 14, 32, "ͼ" );
    locate( 24, 51 );
    delay( 1 );
}


void    main( void )
{
    buzzer();

    if ( ! ISLOADED_ANSI() )
    {
        printf( "ANSI.SYS (or equivalent) needs to be loaded first.\n" );
        exit( 1 );
    }

    color( 2, 2, 1 );                           // red
    ansi_cls( 0, stderr );
    color( 2, 4, 1 );                           // yellow
    print_at( 24, 21, "The official Trudeau salute..." );
    color( 2, 2, 1 );                           // red
    print_at(  4, 32, pic1 );
    print_at(  5, 32, pic2 );
    print_at(  6, 32, pic2 );
    print_at(  7, 32, pic2 );
    print_at(  8, 32, pic2 );
    print_at(  9, 20, " ͺ ͻ" );
    print_at( 10, 20, pic5 );
    print_at( 11, 20, pic5 );
    print_at( 12, 20, pic5 );
    print_at( 13, 20, "    ͺ" );
    print_at( 14, 20, pic6 );
    print_at( 15, 20, pic6 );
    print_at( 16, 20, pic6 );
    print_at( 17, 20, "\\/" );
    print_at( 18, 21, "\\/" );
    print_at( 19, 22, "\\/" );
    print_at( 20, 23, pic7 );
    print_at( 21, 23, pic7 );
    print_at( 22, 23, pic7 );
    finger_down();
    finger_up();
    finger_down();
    finger_up();
    finger_down();
    finger_up();
    finger_down();
    finger_up();
    delay( 6 );
    color( 1, 8, 1 );                           // b/w
    ansi_cls( 0, stderr );
    buzzer();
    exit( 0 );
}
